/*------------------------------------------------------------------------------
 bin/djv_view/magnify.h
 
 Image Magnify
 -------------

 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_VIEW_MAGNIFY_H
#define DJV_VIEW_MAGNIFY_H

#include <djv_ui/dialog.h>
#include "base.h"

namespace djv_view {
namespace view { class Widget; }
namespace magnify
{

//------------------------------------------------------------------------------
// Dialog

class Dialog : public ui::dialog::Base
{
public:
  
  Dialog();

  // Value.
  
  void set(const view::Widget *, const Vec2i & pick);
  void update(const view::Widget *, const Vec2i & pick);
  void del(const view::Widget *);
  
  // Widget.
  
  void show();
  void widget_del();
  
  // Layout.
  
  void update() { Base::update(); }

private:
  
  DJV_CALLBACK(Dialog, zoom_callback, int);
  DJV_CALLBACK(Dialog, close_callback, bool);
  
  void value_update();
  void widget_update();
  
  const view::Widget * _view;
  Vec2i _pick;
  int _zoom;
  bool _update;
  ui::image::Widget * _widget;
  ui::choice::Widget * _zoom_widget;
};

//------------------------------------------------------------------------------
// Labels

const List<Str> & zoom_str();

//------------------------------------------------------------------------------
// Global

Dialog * dialog();

void del();

}
}

#endif
