/*------------------------------------------------------------------------------
 bin/djv_vlut/base.h

 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_VLUT_BASE_H
#define DJV_VLUT_BASE_H

#include <djv_ui/image.h>

namespace djv_vlut
{
using namespace djv;

//------------------------------------------------------------------------------
// Color

struct Color : public ui::image::Display
{
  Str name;
  
  Str lut_file;
  void lut_load();
};

class Color_List
{
public:

  Color_List();
  ~Color_List();
  
  void set(const List<Color> &);
  const List<Color> & get() const { return _list; }
  List<Str> name_list() const;
  ui::Signal<bool> sig;

private:

  List<Color> _list;
};

//------------------------------------------------------------------------------
// Comparison

bool operator == (const Color &, const Color &);
bool operator != (const Color &, const Color &);

//------------------------------------------------------------------------------
// Conversion

bool serialize(List<Str> *, Color *);
List<Str> serialize(const Color &);

//------------------------------------------------------------------------------
// Global

Color_List * color_list();
void color_list_del();

}

#endif

