/*------------------------------------------------------------------------------
 bin/djv_vlut/window.h

 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_VLUT_WINDOW_H
#define DJV_VLUT_WINDOW_H

#include <djv_ui/window.h>
#include "widget.h"

namespace djv_vlut {
namespace window
{

class Widget : public ui::window::Widget
{
public:

  Widget();
  
  void set(const Color &);
  ui::Signal<const Color &> sig;
  
private:

  DJV_CALLBACK(Widget, color_callback, const Color &);
  DJV_CALLBACK(Widget, color_add_callback, const Str &);
  DJV_CALLBACK(Widget, color_del_callback, int);
  DJV_CALLBACK(Widget, color_del_all_callback, bool);
  DJV_CALLBACK(Widget, color_list_callback, bool);
  
  DJV_FL_WIDGET_CALLBACK(Widget, _color_reset_callback);
  DJV_FL_WIDGET_CALLBACK(Widget, _color_add_callback);
  DJV_FL_WIDGET_CALLBACK(Widget, _color_del_callback);
  DJV_FL_WIDGET_CALLBACK(Widget, _color_del_all_callback);
  DJV_FL_WIDGET_CALLBACK(Widget, _color_list_callback);

  DJV_FL_WIDGET_CALLBACK(Widget, _messages_callback);
  DJV_FL_WIDGET_CALLBACK(Widget, _prefs_callback);
  DJV_FL_WIDGET_CALLBACK(Widget, _about_callback);
  DJV_FL_WIDGET_CALLBACK(Widget, _exit_callback);

  DJV_CALLBACK(Widget, image_io_callback, image::io::Plugin *);

  DJV_CALLBACK(Widget, close_callback, bool);

  void value_update();
  void menu_update();
  
  Color _color;
  widget::Widget * _widget;
  ui::menu::Widget * _menu;
  List<int> _menu_color;
};

}
}

#endif

