/*------------------------------------------------------------------------------
 lib/djv_base/io.cxx

 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

//#define DJV_DBG
#define _DBG "lib/djv_base/io.cxx"

#include "io.h"

namespace djv {
namespace io
{

void word(Io * io, char * out, int max_len) throw (Error)
{
  DJV_DBG_OBJ2(_DBG, "word");
  
  out[0] = '\0';
  enum { END, WORD, COMMENT } parse = WORD;
  int i = 0;
  while (parse)
  {
    DJV_DBG_PRN("parse = " << parse);
    DJV_DBG_PRN("i = " << i);

    // Get next character.

    uint8_t c;
    io->get(&c, 1);
    DJV_DBG_PRN("c = \'" << c << "\'");
    
    switch (c)
    {
      // Start comment.

      case '#': parse = COMMENT; break;

      // End comment or word.

      case '\0':
      case '\n':
      case 15: parse = WORD;
      case ' ':
      case '\t': if (out[0]) parse = END; break;

      // Add character to word.

      default:
        if (WORD == parse && i < (max_len - 1)) {
          out[i++] = c;
          //out[i] = '\0';
          //DJV_DBG_PRN("out = \"" << out << "\"");
        }
        break;
    }
  }
  out[i] = '\0';
  DJV_DBG_PRN("out = \"" << out << "\"");
}

}
}
