/*------------------------------------------------------------------------------
 lib/djv_base/time.h
 
 Time
 ----
 
 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_TIME_H
#define DJV_TIME_H

#include <djv_base/type.h>
#if ! defined(WIN32)
#include <sys/time.h>
#endif

namespace djv {
namespace time
{

//------------------------------------------------------------------------------
// Timer

class Timer
{
public:

  Timer();

  void start();
  void check();

  double seconds() const;
  double fps() const;

private:

#if defined(WIN32)
  //DWORD _t0, _t1;
  LARGE_INTEGER _t0, _t1, _frequency;
#else
  timeval _t0, _t1;
#endif
};

//------------------------------------------------------------------------------
// Functions

time_t current();

void sleep(int seconds);

// Conversion.

void seconds_to_time(double, int * hours, int * minutes, double * seconds);

Str time_to_str(time_t);

}
}

#endif

