/*------------------------------------------------------------------------------
 lib/djv_ui/base_.h

 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#include <algorithm>

namespace djv {
namespace ui
{

template <class T>
inline Signal<T>::~Signal() { del(); }

template <class T>
inline void Signal<T>::set(Callback_Base * in, Callback * callback)
{
  in->sig_add(this);
  _list.push_back(Pair(in, (void *)callback));
}

template <class T>
inline void Signal<T>::del(Callback_Base * in)
{
  for (List<Pair>::iterator i = _list.begin(); i != _list.end(); ++i)
    if (in == i->first)
    {
      in->sig_del(this);
      _list.erase(i);
      break;
    }
}

template <class T>
inline void Signal<T>::del()
{
  for (uint i = 0; i < _list.size(); ++i)
    _list[i].first->sig_del(this);
  _list.clear();
}

template <class T>
inline void Signal<T>::emit(T in)
{
  for (uint i = 0; i < _list.size(); ++i)
    ((Callback *)_list[i].second)(_list[i].first, in);
}

template <class T>
inline void Signal<T>::release(Callback_Base * in)
{
  for (List<Pair>::iterator i = _list.begin(); i != _list.end(); ++i)
    if (in == i->first)
    {
      _list.erase(i);
      break;
    }
}

}
}

