/*------------------------------------------------------------------------------
 lib/djv_ui/messages_dialog.h
 
 Messages Dialog
 ---------------

 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_UI_MESSAGES_DIALOG_H
#define DJV_UI_MESSAGES_DIALOG_H

#include <djv_ui/dialog.h>

namespace djv {
namespace ui {
namespace messages_dialog
{

//------------------------------------------------------------------------------
// Dialog

class Dialog : public dialog::Base
{
public:
  
  Dialog();
  
  // Value.
  
  void set(const Str &);
  void set(const Error &);
  void clear();
  
  // Widget.
  
  virtual void widget_del();
  
  // Layout.
  
  virtual void dirty();
  virtual const Vec2i & size_min() const { return _size_min; }
  
private:
  
  DJV_CALLBACK(Dialog, show_callback, bool);
  DJV_CALLBACK(Dialog, clear_callback, bool);
  DJV_CALLBACK(Dialog, close_callback, bool);
  
  void widget_update();
  void dialog_update();
  
  List<Str> _list;
  bool _show;
  text::Multiline_Display * _widget;
  button::Check * _show_widget;
  Vec2i _size_min;
};

//------------------------------------------------------------------------------
// Global

Dialog * global();

void message(const Str &);
void error(const Error &);

void del();

}
}
}

#endif
