/*------------------------------------------------------------------------------
 lib/djv_ui/pixel.cxx
 
 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#include "pixel.h"
#include <djv_ui/layout_row.h>
#include <djv_ui/choice.h>

namespace djv {
namespace ui {
namespace pixel
{

Widget::Widget() : _value(djv::image::PIXEL(0))
{
  add(_widget = new choice::Widget(djv::image::pixel::label_pixel()));
  
  size(layout::FIXED, layout::FIXED);
  align(layout::LEFT, layout::CENTER);
  
  widget_update();
  
  _widget->sig.set(this, widget_callback);
}

void Widget::set(djv::image::PIXEL in)
{
  if (in == _value) return;
  _value = in;
  widget_update();
  sig.emit(_value);
}

void Widget::draw()
{
  widget::Widget::draw();
}

void Widget::widget_del()
{
  _widget->widget_del();
  widget::Widget::widget_del();
}

void Widget::dirty()
{
  widget::Widget::dirty();
  _widget->dirty();
  size_hint(_widget->size_hint());
}

void Widget::geom(const Box2i & in)
{
  widget::Widget::geom(in);
  _widget->geom(in);
}

void Widget::widget_callback(int in)
{
  set(djv::image::PIXEL(in));
}

void Widget::widget_update()
{
  callbacks(false);
  _widget->set(_value);
  callbacks(true);
}

}
}
}
