/*------------------------------------------------------------------------------
 lib/djv_ui/prefs_dialog.h
 
 Preferences Dialog
 ------------------

 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_UI_PREFS_DIALOG_H
#define DJV_UI_PREFS_DIALOG_H

#include <djv_ui/dialog.h>

namespace djv {
namespace ui {
namespace prefs_dialog
{

//------------------------------------------------------------------------------
// Global Preferences Widget

class Global : public widget::Widget
{
public:

  Global();

private:

  DJV_CALLBACK(Global, color_callback, int);
  DJV_CALLBACK(Global, size_callback, int);
  DJV_CALLBACK(Global, timecode_callback, bool);
  DJV_CALLBACK(Global, tooltips_callback, bool);
};

//------------------------------------------------------------------------------
// Image I/O Preferences Widget

class Image_Io : public widget::Widget
{
public:

  Image_Io();

private:

  DJV_CALLBACK(Image_Io, load_callback, djv::image::io::Plugin *);
  DJV_CALLBACK(Image_Io, save_callback, djv::image::io::Plugin *);
};

//------------------------------------------------------------------------------
// Preferences Dialog

class Dialog : public dialog::Base
{
public:
  
  Dialog();

  void add(const Str & name, widget::Base *);
  
private:
  
  DJV_CALLBACK(Dialog, close_callback, bool);
  
  tab::Widget * _tab_widget;
};

//------------------------------------------------------------------------------
// Global

Dialog * global();

void del();

}
}
}

#endif

