/*------------------------------------------------------------------------------
 plugin/djv_exr/fnc.cxx
 
 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#include "plugin.h"
#include <djv_base/box.h>

Box2i imf_box(const Imath::Box2i & in)
{
  return Box2i(
    Vec2i(in.min.x, in.min.y),
    Vec2i(in.max.x, in.max.y) - Vec2i(in.min.x, in.min.y) + 1);
}

Imf::PixelType imf_type(image::pixel::TYPE in)
{
  switch (in)
  {
    case image::pixel::U8:
    case image::pixel::U10:
    case image::pixel::U16: 
    case image::pixel::F16: return Imf::HALF;
    default: break;
  }
  return Imf::FLOAT;
}

image::pixel::TYPE imf_type(Imf::PixelType in)
{
  switch (in)
  {
    case Imf::HALF: return image::pixel::F16;
    default: break;
  }
  return image::pixel::F32;
}

const List<Str> & label_color()
{
  static const List<Str> data = List<Str>() << "Raw" << "Exposure";
  return data;
}

const List<Str> & label_compress()
{
  static const List<Str> data = List<Str>() << "None" << "PIZ" << "ZIP" <<
    "RLE";
  return data;
}

const List<Str> & label_tag()
{
  static const List<Str> data = List<Str>() << "Longitude" << "Latitude" <<
    "Altitude" << "Focus" << "Exposure" << "Aperture" << "ISO Speed" <<
    "Chromaticities" << "White Luminance" << "X Density";
  return data;
}

const List<Str> & label_load_option()
{
  static const List<Str> data = List<Str>() << "Color" << "Exposure";
  return data;
}

const List<Str> & label_save_option()
{
  static const List<Str> data = List<Str>() << "Compress";
  return data;
}

