/*------------------------------------------------------------------------------
 plugin/djv_quicktime_apple/ui.h

 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_QUICKTIME_UI_H
#define DJV_QUICKTIME_UI_H

#include "plugin.h"
#include <djv_ui/image_io.h>

class Save_Widget : public ui::image_io::Save
{
public:

  Save_Widget();
  
  Plugin * copy() const { return new Save_Widget; }

  Str name() const { return ::name; }

  void set(image::io::Plugin *);
  
private:

  DJV_CALLBACK(Save_Widget, codec_callback, int);
  DJV_CALLBACK(Save_Widget, quality_callback, int);

  void plugin_update();
  void widget_update();
  
  image::io::Plugin * _plugin;
  CODEC _codec;
  QUALITY _quality;
  ui::choice::Widget * _codec_widget;
  ui::choice::Widget * _quality_widget;
};

#endif
